#pragma once

#ifdef NAI_IOBOARD_LIB_EXPORTS
#define NAI_IOBOARD_LIB_API __declspec(dllexport)
#else
#define NAI_IOBOARD_LIB_API __declspec(dllimport)
#endif

#include <string>
#include <vector>

namespace NaiStudio
{

    class NAI_IOBOARD_LIB_API DigitalIOBoard
    {
    public:
        DigitalIOBoard(const std::string &port_name, uint16_t inputs_count, uint16_t outputs_count);
        ~DigitalIOBoard();
        void connect();
        void read_all();
        void toggle_one(uint16_t output_offset); // zero-based
        void write_one(uint16_t output_offset, bool value); // zero-based

        #pragma warning( disable: 4251 )
        std::vector<uint16_t> inputs;
        std::vector<uint16_t> outputs;
    };

}
